> For clean Markdown of any page, append .md to the page URL. > For a complete documentation index, see https://developer.ideogram.ai/v1/api-reference/generate/post-upscale-image/llms.txt. > For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://developer.ideogram.ai/_mcp/server. # Upscale POST https://api.ideogram.ai/upscale Content-Type: multipart/form-data Upscale provided images synchronously with an optional prompt. Supported image formats include JPEG, PNG, and WebP. Images links are available for a limited period of time; if you would like to keep the image, you must download it. Reference: https://developer.ideogram.ai/v1/api-reference/generate/post-upscale-image ## Authentication - `Api-Key` header (required) — API key for access control. Use in the header with the name \"Api-Key\" ## Request ### Body (multipart/form-data) This endpoint expects a multipart form containing a file. - `image_request` (UpscaleInitialImageRequest, required) - `image_file` (file, required) — An image binary (max size 25MB); only JPEG, WebP and PNG formats are supported at this time. ## Response ### 200 Image(s) generated successfully. - `created` (datetime, required) — The time the request was created. - `request_id` (string, optional) — URL-safe base64 ID of the sampling request. Present when the caller supplied `webhook_url` and the request was accepted for async delivery; in that case `data` is omitted and the generated images will be POSTed to the customer's `webhook_url` when ready. - `data` (list of ImageObject, optional) — A list of ImageObjects that contain the generated image(s). ## Errors ### 400 Bad Request Error Invalid input provided. - `any` ### 403 Forbidden Error Not authorized to generate an image. - `any` ### 422 Unprocessable Entity Error Prompt or provided image failed safety check. - `error` (string, required) ### 429 Too Many Requests Error Too many requests. - `any` ## Types ### ImageObject - `prompt` (string, required) — The prompt used for the generation. This may be different from the original prompt. - `resolution` (string, required) — The resolution of the final image. - `is_image_safe` (boolean, required) — Whether this request passes safety checks. If false, the url field will be empty. - `seed` (integer, required) — Random seed. Set for reproducible generation. - `url` (string, optional, nullable) — The direct link to the image generated. - `upscaled_resolution` (string, optional) — Output resolution, only used if operations alters image dimensions, such as upscale, crop etc. - `style_type` (enum, optional) — The style type to generate with; this is only applicable for models V_2 and above and should not be specified for model versions V_1. - Allowed values: `AUTO`, `GENERAL`, `FICTION`, `REALISTIC`, `DESIGN`, `RENDER_3D`, `ANIME` ## Examples **Request** ```json { "image_file": ">", "image_request": { "resemblance": 55, "detail": 90 } } ``` **Response** ```json { "created": {}, "data": [ { "prompt": "A photo of a cat", "resolution": "1280x800", "is_image_safe": true, "seed": 12345, "url": "https://ideogram.ai/api/images/ephemeral/xtdZiqPwRxqY1Y7NExFmzB.png?exp=1743867804&sig=e13e12677633f646d8531a153d20e2d3698dca9ee7661ee5ba4f3b64e7ec3f89", "style_type": "GENERAL" } ] } ``` **SDK Code** ```python import requests import json response = requests.post( "https://api.ideogram.ai/upscale", headers={ "Api-Key": "" }, data={ "image_request": json.dumps({ "resemblance": 55, "detail": 90 }) }, files={ "image_file": open("", "rb") } ) print(response.json()) with open('output.png', 'wb') as f: f.write(requests.get(response.json()['data'][0]['url']).content) ``` ```typescript const formData = new FormData(); formData.append('image_request', JSON.stringify({ resemblance: 55, detail: 90 })); formData.append('image_file', new Blob([fs.readFileSync("")], { type: 'image/png' })); const response = await fetch('https://api.ideogram.ai/upscale', { method: 'POST', headers: { 'Api-Key': '' }, body: formData }); const data = await response.json(); console.log(data); ``` ```go package main import ( "fmt" "strings" "net/http" "io" ) func main() { url := "https://api.ideogram.ai/upscale" payload := strings.NewReader("-----011000010111000001101001\r\nContent-Disposition: form-data; name=\"image_file\"; filename=\"\"\r\nContent-Type: application/octet-stream\r\n\r\n\r\n-----011000010111000001101001\r\nContent-Disposition: form-data; name=\"image_request\"\r\n\r\n{\n \"resemblance\": 55,\n \"detail\": 90\n}\r\n-----011000010111000001101001--\r\n") req, _ := http.NewRequest("POST", url, payload) req.Header.Add("Api-Key", "") req.Header.Add("Content-Type", "multipart/form-data; boundary=---011000010111000001101001") res, _ := http.DefaultClient.Do(req) defer res.Body.Close() body, _ := io.ReadAll(res.Body) fmt.Println(res) fmt.Println(string(body)) } ``` ```ruby require 'uri' require 'net/http' url = URI("https://api.ideogram.ai/upscale") http = Net::HTTP.new(url.host, url.port) http.use_ssl = true request = Net::HTTP::Post.new(url) request["Api-Key"] = '' request["Content-Type"] = 'multipart/form-data; boundary=---011000010111000001101001' request.body = "-----011000010111000001101001\r\nContent-Disposition: form-data; name=\"image_file\"; filename=\"\"\r\nContent-Type: application/octet-stream\r\n\r\n\r\n-----011000010111000001101001\r\nContent-Disposition: form-data; name=\"image_request\"\r\n\r\n{\n \"resemblance\": 55,\n \"detail\": 90\n}\r\n-----011000010111000001101001--\r\n" response = http.request(request) puts response.read_body ``` ```java import com.mashape.unirest.http.HttpResponse; import com.mashape.unirest.http.Unirest; HttpResponse response = Unirest.post("https://api.ideogram.ai/upscale") .header("Api-Key", "") .header("Content-Type", "multipart/form-data; boundary=---011000010111000001101001") .body("-----011000010111000001101001\r\nContent-Disposition: form-data; name=\"image_file\"; filename=\"\"\r\nContent-Type: application/octet-stream\r\n\r\n\r\n-----011000010111000001101001\r\nContent-Disposition: form-data; name=\"image_request\"\r\n\r\n{\n \"resemblance\": 55,\n \"detail\": 90\n}\r\n-----011000010111000001101001--\r\n") .asString(); ``` ```php request('POST', 'https://api.ideogram.ai/upscale', [ 'multipart' => [ [ 'name' => 'image_file', 'filename' => '', 'contents' => null ], [ 'name' => 'image_request', 'contents' => '{ "resemblance": 55, "detail": 90 }' ] ] 'headers' => [ 'Api-Key' => '', ], ]); echo $response->getBody(); ``` ```csharp using RestSharp; var client = new RestClient("https://api.ideogram.ai/upscale"); var request = new RestRequest(Method.POST); request.AddHeader("Api-Key", ""); request.AddParameter("multipart/form-data; boundary=---011000010111000001101001", "-----011000010111000001101001\r\nContent-Disposition: form-data; name=\"image_file\"; filename=\"\"\r\nContent-Type: application/octet-stream\r\n\r\n\r\n-----011000010111000001101001\r\nContent-Disposition: form-data; name=\"image_request\"\r\n\r\n{\n \"resemblance\": 55,\n \"detail\": 90\n}\r\n-----011000010111000001101001--\r\n", ParameterType.RequestBody); IRestResponse response = client.Execute(request); ``` ```swift import Foundation let headers = [ "Api-Key": "", "Content-Type": "multipart/form-data; boundary=---011000010111000001101001" ] let parameters = [ [ "name": "image_file", "fileName": "" ], [ "name": "image_request", "value": "{ \"resemblance\": 55, \"detail\": 90 }" ] ] let boundary = "---011000010111000001101001" var body = "" var error: NSError? = nil for param in parameters { let paramName = param["name"]! body += "--\(boundary)\r\n" body += "Content-Disposition:form-data; name=\"\(paramName)\"" if let filename = param["fileName"] { let contentType = param["content-type"]! let fileContent = String(contentsOfFile: filename, encoding: String.Encoding.utf8) if (error != nil) { print(error as Any) } body += "; filename=\"\(filename)\"\r\n" body += "Content-Type: \(contentType)\r\n\r\n" body += fileContent } else if let paramValue = param["value"] { body += "\r\n\r\n\(paramValue)" } } let request = NSMutableURLRequest(url: NSURL(string: "https://api.ideogram.ai/upscale")! as URL, cachePolicy: .useProtocolCachePolicy, timeoutInterval: 10.0) request.httpMethod = "POST" request.allHTTPHeaderFields = headers request.httpBody = postData as Data let session = URLSession.shared let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in if (error != nil) { print(error as Any) } else { let httpResponse = response as? HTTPURLResponse print(httpResponse) } }) dataTask.resume() ```